		#  UNMASM
		#  / Ha3sm / reference / Forthy / colorForth
		#  COLOR.ASM
		#  Sat Aug 23 11:13:39 2003

		#  colorForth , 2001 Jul 22 , Chuck Moore , Public Domain


#	.MODEL tiny
#	.486p
#	only $(( SEGMENT USE32 ))
#	ASSUME DS:only


	next ( ) {		#  MACRO _		#  ######HAND-CONVERT ARGUMENTS
		#  ##adr=$1  ...
	1- C
	 when  not zero $1
	}


	DUP_ ( ) {		#  MACRO _
	address @ SI $(( - 4 )) to SI
	= A to @ SI
	}


	DROP ( ) {		#  MACRO _
	ab 0xad		#  ### lodsd
	}


		#  hp equ 800
		#  vp equ 600
		#  vesa equ 114h
hp=1024 
vp=768 
vesa=0x117 
buffer=$((604*  256 ))
	. boot.asm		#  boot boot0 hard


		#  100000 dictionary
		#  a0000 top of			return stack
		#  9f800 top of data stack
		#  9d800 free
		#  97000 floppy buffer
		#  4800 source
icons=$((12*  256 * 4 ))		#  3000
		#  7c00 BIOS boot sector
		#  0 Forth


L  warm
	DUP_
L  start1
	  call  ATI0
		#  mov screen , offset nul
		#  xor EAX , EAX
	  call  show0
	= $(( ( forth1 - forth0 ) / 4 )) to forths
	= $(( ( macro1 - macro0 ) / 4 )) to macros
	= 18 to A
	  call  LOAD
	jump ACCEPT


Gods=$((0x28000*  4 ))		#  0A0000h
Godd=$((Gods-  750 * 4 ))
mains=$((Godd-  1500 * 4 ))
maind=$((mains-  750 * 4 ))
	align 4
L  me
	aq God
L  screen
	aq 0		#  logo


L  ROUND
	  call  unPAUSE
L  God
	aq 0		#  Gods - 2 * 4
	  call  unPAUSE
L  main
	aq 0		#  mains - 2 * 4
	jump ROUND


L  PAUSE
	DUP_
	push SI
	= me to A
	= SP to @ A
	+ 4 to A
	jump A


L  unPAUSE
	pull A
	= @ A to SP
	= A to me
	pull SI
	DROP
			return



L  ACT
	= $(( maind - 4 )) to D
	= A to @ D
	= $(( mains - 4 )) to A
	pull @ A
	- 4 to A
	= D to @ A
	= A to main
	DROP
			return



L  show0
	  call  show
			return

L  show
	pull screen
	DUP_
	zero A
	  call  ACT
L  l__1
	  call  graphic
	  call  @ screen
	  call  SWITCH
	1+ A
	jump l__1


L  c_
	= $(( Godd + 4 )) to SI
			return



L  mark
	= macros to C
	= C to mk
	= forths to C
	= C to $(( mk + 4 ))
	= H to C
	= C to $(( mk + 2 * 4 ))
			return



L  empty
	= $(( mk + 2 * 4 )) to C
	= C to H
	= $(( mk + 4 )) to C
	= C to forths
	= mk to C
	= C to macros
	= 0 to class
			return



L  mFIND
	= macros to C
	push DI
	address @ $(( macro0 - 4 )) C *2^ 2 to DI
	jump l__2


L  FIND
	= forths to C
	push DI
	address @ $(( forth0 - 4 )) C *2^ 2 to DI
L  l__2
	decreasing
	ab 0xf2 0xaf		#  ### SCAN ONE CELL?cld
	increasing
	pull DI
			return



L  EX1
	1- words		#  from keyboard
	 when  zero l__3
	DROP
	jump EX1
L  l__3
	  call  FIND
	 when  not zero ABORT1
	DROP
	jump @ $(( forth2 )) C *2^ 2


L  execute
	= alit to lit
	DUP_
	= @ $(( - 4 )) DI *2^ 2 to A
L  ex2
	AND $(( - 020 )) to A
	  call  FIND
	 when  not zero ABORT
	DROP
	jump @ $(( forth2 )) C *2^ 2


L  ABORT
	= DI to curs
	downshift $(( 10 - 2 )) to DI
	= DI to blk
L  ABORT1
	= Gods to SP
	= forthd to $(( spaces + 3 * 4 ))
	= qcompile to $(( spaces + 4 * 4 ))
	= cnum to $(( spaces + 5 * 4 ))
	= cshort to $(( spaces + 6 * 4 ))
	= 057 to A		#  ?
	  call  ECHO_
	jump ACCEPT


L  sDEFINE
	pull aDEFINE

			return

L  MACRO_
	  call  sDEFINE
L  macrod
	= macros to C
	1+ macros
	address @ $(( macro0 )) C *2^ 2 to C
	jump l__4


L  FORTH
	  call  sDEFINE
L  forthd
	= forths to C
	1+ forths
	address @ $(( forth0 )) C *2^ 2 to C
L  l__4
	= @ $(( - 4 )) DI *2^ 2 to D
	AND $(( - 020 )) to D
	= D to @ C
	= h to D
	= D to @ $(( forth2 - forth0 )) C
	address @ $(( forth2 - forth0 )) C to D
	downshift 2 to D
	= D to @ $last
	= SP to @ $list
	= adup to @ $lit
	ANDtest $(( - 1 )) to class
	 when  zero l__5
	jump @ class
L  l__5
			return



L  cdrop
	= h to D
	= D to @ $list
	= 0x0ad to byte @ D		#  lodsd
	1+ h
			return



L  qdup
	= h to D
	1- D
	-test D to @ $list
	 when  not zero cdup
	-test 0x0ad to byte @ D
	 when  not zero cdup
	= D to h
			return


L  cdup
	= h to D
	= 0x89fc768d to @ D
	= 06 to byte @ $(( 4 )) D
	+ 5 to h
			return



L  adup
	DUP_
			return



L  var1
	DUP_
	= @ $(( 4 + forth0 )) C *2^ 2 to A
			return

L  variable
	  call  forthd
	= var1 to @ $(( forth2 - forth0 )) C
	1+ forths		#  dummy entry for source address
	= DI to @ $(( 4 )) C
	  call  macrod
	= l__6 to @ $(( forth2 - forth0 )) C
	1+ macros
	= DI to @ $(( 4 )) C
	1+ DI
			return

L  l__6
	  call  @ lit
	= @ $(( 4 + macro0 )) C *2^ 2 to A
	jump l__7


L  cNUM
	  call  @ lit
	= @ DI *2^ 2 to A
	1+ DI
	jump l__7


L  cSHORT
	  call  @ lit
	= @ $(( - 4 )) DI *2^ 2 to A
	signeddownshift 5 to A
L  l__7
	  call  literal
	DROP
			return



L  alit
	= adup to lit
L  literal
	  call  qDUP
	= list to D
	= D to $(( list + 4 ))
	= h to D
	= D to @ $list
	= 0x0b8 to byte @ D
	= A to @ $(( 1 )) D
	+ 5 to h
			return



L  qCOMPILE
	  call  @ lit
	= @ $(( - 4 )) DI *2^ 2 to A
	AND $(( - 020 )) to A
	  call  mFIND
	 when  not zero l__8
	DROP
	jump @ $(( macro2 )) C *2^ 2
L  l__8
	  call  FIND
	= @ $(( forth2 )) C *2^ 2 to A
L  l__9
	 when  not zero ABORT
L  call_
	= h to D
	= D to @ $list
	= 0x0e8 to byte @ D
	+ 5 to D
	- D to A
	= A to @ $(( - 4 )) D
	= D to h
	DROP
			return



L  COMPILE
	  call  @ lit
	= @ $(( - 4 )) DI *2^ 2 to A
	AND $(( - 020 )) to A
	  call  mFIND
	= @ $(( macro2 )) C *2^ 2 to A
	jump l__9


L  SHORT_
	= alit to @ $lit
	DUP_
	= @ $(( - 4 )) DI *2^ 2 to A
	signeddownshift 5 to A
			return



L  NUM
	= alit to @ $lit
	DUP_
	= @ DI *2^ 2 to A
	1+ DI
			return



L  comma
	= 4 to C
L  l__10
	= h to D
	= A to @ D
	= @ SI to A		#  drop
	address @ D + C to D
	address @ SI $(( + 4 )) to SI
	= D to h
		#  DROP
			return



L  comma1
	= 1 to C
	jump l__10


L  comma2
	= 2 to C
	jump l__10


L  comma3
	= 3 to C
	jump l__10


L  semi
	= h to D
	- 5 to D
	-test D to @ $list
	 when  not zero l__11
	-test 0x0e8 to byte @ D
	 when  not zero l__11
	1+ byte @ D		#  jmp
			return

L  l__11
	= 0x0c3 to byte @ $(( 5 )) D		#  ret

	1+ h
			return



L  then
	= SP to @ $list
	= h to D
	- A to D
	= DL to @ $(( - 1 )) A
	DROP
			return



L  begin
	= SP to @ $list
L  here
	DUP_
	= h to A
			return



L  qlit
	= h to D
	address @ D $(( - 5 )) to D
	-test D to @ $list
	 when  not zero l__12
	-test 0x0b8 to byte @ D
	 when  not zero l__12
	DUP_
	= $(( list + 4 )) to A
	= A to list
	= @ $(( 1 )) D to A
	-test 0x89fc768d to @ D $(( - 5 ))		#  dup
	 when  zero q1
	= D to h
	jump cdrop
L  q1
	+ $(( - 10 )) to h		#  flag nz
			return

L  l__12
	XOR D to D		#  flag z
			return



L  less
	-test A to @ SI
	 when  sign		 l__13		#  flag nz
	zero C
L  l__13
			return



L  qIGNORE
	ANDtest $(( - 020 )) to @ $(( - 4 )) DI *2^ 2
	 when  not zero nul
	pull DI
	pull DI
L  nul
			return



L  jump
	pull D
	+ A to D
	address @ $(( 5 )) A *2^ $(( 2 )) D to D
	+ @ $(( - 4 )) D to D
	DROP
	jump D


L  LOAD
	upshift $(( 10 - 2 )) to A
	push DI
	= A to DI
	DROP
L  INTER
	= @ DI *2^ 2 to D
	1+ DI
	AND 017 to D
	  call  spaces @ D *2^ 2
	jump INTER


	align 4
L  spaces
	aq qIGNORE execute NUM
L  aDEFINE
	aq $(( 5 + MACRO_ ))		#  offset macrod ?
	aq qCOMPILE cNUM cSHORT COMPILE

	aq SHORT_ nul nul nul
	aq variable nul nul nul


L  lit
	aq adup
L  mk
	aq 0 0 0
L  H
	aq $(( 0x40000 * 4 ))
L  last
	aq 0
L  class
	aq 0
L  list
	aq 0 0
L  macros
	aq 0
L  forths
	aq 0
		#  macro0 dd ( 3 << 4 + 1 ) << 24		#  or
		#  dd ( ( 5 << 4 + 6 ) << 7 + 140o ) << 17		#  and
		#  dd 173o << 25		#  +
L  macro0
	aq $(( 0170 << 25 ))		# 		# 
	rpn 0140 7 << 0146 + 7 << 0142 + 11 << ,		#  dup
	rpn 0177 7 << 0140 + 7 << 0146 + 7 << 0142 + 4 << ,		#  ?dup
	rpn 0140 4 << 1 + 4 << 3 + 7 << 0142 + 10 << ,		#  drop
		#  dd ( ( 6 << 4 + 7 ) << 7 + 142o ) << 17		#  nip
	rpn 2 7 << 0144 + 4 << 4 + 4 << 6 + 13 << ,		#  then
	rpn 0143 4 << 4 + 5 << 025 + 4 << 7 + 4 << 6 + 8 << ,		#  begin
L  macro1
	rpn 128 0 dup
L  forth0
	rpn 0143 4 << 3 + 4 << 3 + 4 << 2 + 13 << ,		#  boot
	rpn 027 4 << 5 + 4 << 1 + 5 << 021 + 14 << ,		#  warm
	rpn 0142 4 << 5 + 7 << 0146 + 5 << 020 + 4 << 4 + 5 << ,		#  pause
	rpn 021 4 << 5 + 5 << 022 + 4 << 1 + 4 << 3 + 10 << ,		#  MACRO

	rpn 026 4 << 3 + 4 << 1 + 4 << 2 + 7 << 0144 + 8 << ,		#  FORTH
	aq $(( 022 << 27 ))		#  c
	rpn 020 4 << 2 + 4 << 3 + 7 << 0142 + 12 << ,		#  stop
	rpn 1 4 << 4 + 4 << 5 + 7 << 0140 + 13 << ,		#  read
	rpn 027 4 << 1 + 4 << 7 + 4 << 2 + 4 << 4 + 11 << ,		#  write
	rpn 6 5 << 022 + 23 << ,		#  nc
	rpn 022 4 << 3 + 5 << 021 + 5 << 021 + 4 << 5 + 4 << 6 + 5 << ,		#  comman d
	rpn 020 4 << 4 + 4 << 4 + 7 << 0164 + 12 << ,		#  seek
	rpn 1 4 << 4 + 4 << 5 + 7 << 0140 + 5 << 023 + 8 << ,		#  ready
		#  dd ( ( ( 22o << 5 + 24o ) << 4 + 1 ) << 4 + 7 ) << 14		#  clri
	rpn 5 5 << 022 + 4 << 2 + 19 << ,		#  ACT
	rpn 020 7 << 0144 + 4 << 3 + 5 << 027 + 11 << ,		#  SHOW
	rpn 024 4 << 3 + 4 << 5 + 7 << 0140 + 12 << ,		#  LOAD
	rpn 0144 4 << 4 + 4 << 1 + 4 << 4 + 13 << ,		#  here
	rpn 0177 5 << 024 + 4 << 7 + 4 << 2 + 12 << ,		#  ?lit
	rpn 0153 7 << 0176 + 18 << ,		#  3 ,
	rpn 0152 7 << 0176 + 18 << ,		#  2 ,
	rpn 0151 7 << 0176 + 18 << ,		#  1 ,
	aq $(( 0176 << 25 ))		#  ,
	rpn 024 4 << 4 + 5 << 020 + 5 << 020 + 13 << ,		#  less
	rpn 0162 7 << 0146 + 5 << 021 + 7 << 0142 + 6 << ,		#  jump
	rpn 5 5 << 022 + 5 << 022 + 4 << 4 + 7 << 0142 + 4 << 2 + 3 << ,		#  accept
	rpn 0142 4 << 5 + 7 << 0140 + 14 << ,		#  pad
	rpn 4 4 << 1 + 4 << 5 + 5 << 020 + 4 << 4 + 11 << ,		#  erase
	rpn 022 4 << 3 + 7 << 0142 + 5 << 023 + 11 << ,		#  copy
	rpn 021 4 << 5 + 4 << 1 + 7 << 0164 + 12 << ,		#  mark
	rpn 4 5 << 021 + 7 << 0142 + 4 << 2 + 12 << ,		#  empt
	rpn 4 5 << 021 + 4 << 7 + 4 << 2 + 15 << ,		#  emit
	rpn 0140 4 << 7 + 5 << 025 + 4 << 7 + 4 << 2 + 8 << ,		#  digit
	rpn 0152 4 << 4 + 5 << 021 + 4 << 7 + 4 << 2 + 8 << ,		#  2emit
	aq $(( 0165 << 25 ))		#  .
	rpn 0144 7 << 0165 + 18 << ,		#  h.
	rpn 0144 7 << 0165 + 4 << 6 + 14 << ,		#  h.n
	rpn 022 4 << 1 + 23 << ,		#  CR
	rpn 020 7 << 0142 + 4 << 5 + 5 << 022 + 4 << 4 + 7 << ,		#  space
	rpn 0140 4 << 3 + 5 << 027 + 4 << 6 + 12 << ,		#  DOWN
	rpn 4 7 << 0140 + 4 << 7 + 4 << 2 + 13 << ,		#  edit
	aq $(( 4 << 28 ))		#  E
		#  dd ( ( ( 26o << 4 + 3 ) << 4 + 6 ) << 4 + 2 ) << 15		#  font
	rpn 024 5 << 021 + 22 << ,		#  lm
	rpn 1 5 << 021 + 23 << ,		#  rm
	rpn 025 4 << 1 + 4 << 5 + 7 << 0142 + 7 << 0144 + 5 << ,		#  graph ic
	rpn 2 4 << 4 + 7 << 0145 + 4 << 2 + 13 << ,		#  text
		#  dd ( 153o << 7 + 140o ) << 18		#  3d
		#  dd ( ( ( ( ( 1 << 4 + 4 ) << 4 + 6 ) << 7 + 140o ) << 4 + 4 ) << 4 + 1 ) << 5		#  render
		#  dd ( ( ( ( 141o << 4 + 4 ) << 4 + 1 ) << 4 + 2 ) << 4 + 4 ) << 9		#  verte x
		#  dd ( ( ( ( 26o << 4 + 1 ) << 4 + 3 ) << 4 + 6 ) << 4 + 2 ) << 11		#  front
		#  dd ( ( 2 << 4 + 3 ) << 7 + 142o ) << 17		#  top
		#  dd ( ( ( 20o << 4 + 7 ) << 7 + 140o ) << 4 + 4 ) << 12		#  side
	rpn 0164 4 << 4 + 5 << 023 + 7 << 0143 + 4 << 3 + 5 << ,		#  keybo ard
	rpn 0140 4 << 4 + 7 << 0143 + 7 << 0146 + 7 << ,		#  debu g
	rpn 5 4 << 2 + 24 << ,		#  at
	rpn 0173 4 << 5 + 4 << 2 + 17 << ,		#  + at
	rpn 0145 5 << 023 + 20 << ,		#  xy
	rpn 026 4 << 3 + 7 << 0141 + 16 << ,		#  fov
	rpn 026 4 << 7 + 5 << 026 + 4 << 3 + 14 << ,		#  fifo
	rpn 0143 4 << 3 + 7 << 0145 + 14 << ,		#  box
	rpn 024 4 << 7 + 4 << 6 + 4 << 4 + 15 << ,		#  line
	rpn 022 4 << 3 + 5 << 024 + 4 << 3 + 4 << 1 + 10 << ,		#  color
		#  dd ( ( ( 22o << 5 + 24o ) << 4 + 7 ) << 7 + 142o ) << 11		#  clip
	rpn 3 5 << 022 + 4 << 2 + 4 << 5 + 4 << 6 + 4 << 2 + 7 << ,		#  octant
	rpn 020 7 << 0142 + 20 << ,		#  sp
	rpn 024 4 << 5 + 5 << 020 + 4 << 2 + 14 << ,		#  last
	rpn 0146 4 << 6 + 7 << 0142 + 4 << 5 + 5 << 022 + 5 << ,		#  unpac k
		#  dd ( ( ( 142o << 4 + 5 ) << 5 + 22o ) << 7 + 164o ) << 9		#  pack
L  forth1
	rpn 512 0 dup
		#  macro2 dd offset cOR
		#  dd offset cAND
		#  dd offset PLUS
L  macro2
	aq semi
	aq cdup
	aq qdup
	aq cdrop
		#  dd offset nip
	aq then
	aq begin
	rpn 128 0 dup
L  forth2
	aq boot
	aq warm
	aq PAUSE
	aq MACRO_
	aq FORTH
	aq c_
	aq stop
	aq readf
	aq writef
	aq nc_
	aq cmdf
	aq seekf
	aq readyf
	aq ACT
	aq SHOW
	aq LOAD
	aq here
	aq qlit
	aq COMMA3
	aq COMMA2
	aq COMMA1
	aq COMMA
	aq less
	aq jump
	aq ACCEPT
	aq pad
	aq erase
	aq copy
	aq mark
	aq empty
	aq emit
	aq eDIG
	aq emit2
	aq dot10
	aq hdot
	aq hdotn
	aq CR
	aq space
	aq DOWN
	aq edit
	aq E
		#  dd offset font
	aq LMs
	aq RMs
	aq graphic
	aq text1
		#  dd offset set3d
		#  dd offset render
		#  dd offset vertex
		#  dd offset front
		#  dd offset top_
		#  dd offset side
	aq keyboard
	aq debug
	aq at
	aq pat
	aq xy_
	aq fov_
	aq fifof
	aq box
	aq line
	aq color
		#  dd offset clip
	aq octant
	aq sps
	aq last_
	aq unpack
		#  dd offset pack
	rpn 512 0 dup


L  boot
	= 0x0FE to AL		#  Reset
	send AL to 0x64
	jump $H


L  erase
	= A to C
	upshift 8 to C
	DROP
	push DI

	= A to DI
	upshift $(( 2 + 8 )) to DI
	zero A
	fill pull DI
	DROP
			return



		#  move: mov ECX , EAX
		#  DROP
		#  mov EDI , EAX
		#  << EDI , 2
		#  DROP
		#  push ESI
		#  mov ESI , EAX
		#  << ESI , 2
		#  rep movsd
		#  pop ESI
		#  DROP
		#  ret


L  copy
	-test 12 to A
	 when  carry		 ABORT1
	= A to DI
	upshift $(( 2 + 8 )) to DI
	push SI
	= blk to SI
	upshift $(( 2 + 8 )) to SI
	= 256 to C
	copies pull SI
	= A to blk
	DROP
			return



L  debug
	= $(( 3 * 0x10000 + ( vc - 2 ) * ih + 3 )) to xy
	DUP_
	= God to A
	push @ A
	  call  dot
	DUP_
	pull A
	  call  dot
	DUP_
	= main to A
	  call  dot
	DUP_
	= SI to A
	jump dot


iw=$((16+  6 ))
ih=$((24+  6 ))
hc=$((hp/  iw ))		#  46
vc=$((vp/  ih ))		#  25
	align 4
L  xy
	aq $(( 3 * 0x10000 + 3 ))
L  lm
	aq 3
L  rm
	aq $(( hc * iw ))		#  1012
L  xycr
	aq 0
L  fov
	rpn 10 2 * 2 /


L  nc_
	DUP_
	= $(( ( nc - start ) / 4 )) to A
			return



L  xy_
	DUP_
	= $(( ( xy - start ) / 4 )) to A
			return



L  fov_
	DUP_
	= $(( ( fov - start ) / 4 )) to A
			return



L  sps
	DUP_
	= $(( ( spaces - start ) / 4 )) to A
			return



L  last_
	DUP_
	= $(( ( last - start ) / 4 )) to A
			return



	. gen.asm		#  cce.asm pio.asm ATI128.asm ATI64.asm gen.asm


yellow=0x0ffff00 
L  CYAN
	DUP_
	= 0x0ffff to A
	jump color
L  MAGENTA
	DUP_
	= 0x0ff00ff to A
	jump color
L  SILVER
	DUP_
	= 0x0c0c0c0 to A
	jump color
L  BLUE
	DUP_
	= 0x4040ff to A
	jump color
L  RED
	DUP_
	= 0x0ff0000 to A
	jump color
L  GREEN
	DUP_
	= 0x8000ff00 to A
	jump color


L  history
	ab $(( 11 dup ( 0 ) ))
L  ECHO_
	push SI
	= $(( 11 - 1 )) to C
	address history to DI
	address @ $(( 1 )) DI to SI
	copies $(( bytes pull )) SI
	= AL to $(( history + 11 - 1 ))
	DROP
			return



L  RIGHT
	DUP_
	= 11 to C
	address history to DI
	zero A
	fill $(( bytewise DROP ))
			return



L  DOWN
	DUP_
	zero D
	= ih to C
	/ C
	= D to A
	+ $(( 3 * 0x10000 + 0x8000 - ih + 3 )) to D
	= D to xy
L  ZERO
	ANDtest A to A
	= 0 to A
	 when  not zero l__14
	1+ A
L  l__14
			return



L  blank
	DUP_
	zero A
	= A to xy
	  call  color
	DUP_
	= hp to A
	DUP_
	= vp to A
	jump box


L  TOP
	= lm to C
	upshift 16 to C
	+ 3 to C
	= C to @ $xy
	= C to @ $xycr
			return



L  qcr
	otheroperandsize ; = $(( xy + 2 )) to CX
	otheroperandsize ; -test rm to CX
	 when  sign		 l__15
L  cr
	= lm to C
	upshift 16 to C
	otheroperandsize ; = xy to CX
	+ ih to C
	= C to @ $xy
L  l__15
			return



L  LMs
	= A to @ $lm
	DROP
			return



L  RMs
	= A to @ $rm
	DROP
			return



L  at
	otheroperandsize ; = AX to @ $xy
	DROP
	otheroperandsize ; = AX to @ $(( xy + 2 ))
	DROP
			return



L  pAT
	otheroperandsize ; + AX to @ $xy
	DROP
	otheroperandsize ; + AX to @ $(( xy + 2 ))
	DROP
			return




		#  cl1: xor EAX , EAX
		#  mov @ ESI , EAX
		#  ret
		#  clip: movsx EDX , word ptr xy
		#  cmp EDX , vp
		#  jns cl1
		#  add EAX , EDX
		#  js cl1
		#  test EDX , EDX
		#  jns @f
		#  xor EDX , EDX
		#  @@: cmp EAX , vp
		#  js @f
		#  mov EAX , vp
		#  @@: sub EAX , EDX
		#  mov word ptr xy , DX
		#  movsx EDX , word ptr xy + 2
		#  cmp EDX , hp
		#  jns cl1
		#  add @ ESI , EDX
		#  js cl1
		#  test EDX , EDX
		#  jns @f
		#  xor EDX , EDX
		#  @@: cmp dword ptr @ ESI , hp
		#  js @f
		#  mov dword ptr @ ESI , hp
		#  @@: sub @ ESI , EDX
		#  mov word ptr xy + 2 , DX
		#  ret


L  octant
	DUP_
	= 0x43 to A		#  poly - last y + x +	#  23h#  last y + x +
	= @ $(( 4 )) SI to D
	ANDtest D to D
	 when  not sign		 l__16
	negate D
	= D to @ $(( 4 )) SI
L  l__16
	-test @ SI to D
	 when  not sign		 l__17
L  l__17
			return



		#  Keyboard
L  EIGHT
	+ 12 to DI
	  call  FOUR
	  call  SPACE
	- 16 to DI
L  FOUR
	= 4 to C
L  FOUR1
	push C
	DUP_
	zero A
	= @ $(( 4 )) DI to AL
	1+ DI
	  call  EMIT
	pull C
	next FOUR1
			return



L  stack
	= $(( Godd - 4 )) to DI
L  l__18
	= God to D
	-test DI to @ D
	 when  not carry		 l__19
	DUP_
	= @ DI to A
	- 4 to DI

	  call  qDOT
	jump l__18
L  l__19
			return



L  KEYBOARD
	  call  text1
	= board to DI
	DUP_
	= keyc to A
	  call  color
	= $(( hc * iw )) to @ $rm
	= $(( hp - 9 * iw + 3 )) to @ $lm
	= $(( ( hp - 9 * iw + 3 ) * 0x10000 + vp - 4 * ih + 3 )) to @ $xy
	  call  EIGHT
	  call  EIGHT
	  call  EIGHT
	  call  CR
	+ $(( 4 * iw * 0x10000 )) to @ $xy
	= shift to DI
	+ $(( 4 * 4 - 4 )) to DI
	= 3 to C
	  call  FOUR1
	= 3 to @ $lm
	otheroperandsize ; = 3 to @ $(( xy + 2 ))
	  call  stack
	otheroperandsize ; = $(( hp - ( 11 + 9 ) * iw + 3 )) to @ $(( xy + 2 ))
	address $(( history - 4 )) to DI
	= 11 to C
	jump FOUR1


L  alpha
	ab 015 012 1 014
	ab 024 2 6 010
	ab 023 011 017 021
	ab 022 013 016 7
	ab 5 3 4 026
	ab 027 044 025 020
L  graphics
	ab 031 032 033 0
	ab 034 035 036 030
	ab 037 040 041 057
	ab 051 050 052 054		#  :		#  ! @
	ab 046 042 045 056		#  Z J . ,
	ab 055 047 053 043		#  * / + -
L  numbers
	ab 031 032 033 0
	ab 034 035 036 030
	ab 037 040 041 0
	ab 0 0 0 0
	ab 0 0 0 0
	ab 0 0 0 0
L  octals
	ab 031 032 033 0
	ab 034 035 036 030
	ab 037 040 041 0
	ab 0 5 023 012
	ab 0 020 4 016
	ab 0 0 0 0
L  LETTER
	-test 4 to AL
	 when  sign		 l__20
	= board to D
	= @ D @ A to AL
L  l__20
			return



L  keys
	ab 16 17 18 19 0 0 4 5		#  20
	ab 6 7 0 0 0 0 20 21
	ab 22 23 0 0 8 9 10 11		#  40
	ab 0 0 0 0 24 25 26 27
	ab 0 1 12 13 14 15 0 0		#  60 N
	ab 3 2		#  alt space
L  KEY
	DUP_
	zero A
L  l__21
	  call  PAUSE
	recieve 0144 to AL
	ANDtest 1 to AL
	 when  zero l__21
	recieve 0140 to AL
	ANDtest 0360 to AL
	 when  zero l__21
	-test 072 to AL
	 when  not carry		 l__21
	= @ $(( keys - 020 )) A to AL
			return



	align 4
L  graph0
	aq nul0 nul0 nul0 ALPH0
	ab 0 0 5 0		#  a
L  graph1
	aq WORD0 X LJ ALPH
	ab 025 045 5 0		#  x . a
L  alpha0
	aq nul0 nul0 NUMBER STAR0
	ab 0 041 055 0		#  9 *
L  alpha1
	aq WORD0 X LJ GRAPH
	ab 025 045 055 0		#  x . *
L  numb0
	aq nul0 MINUS ALPHn OCTAL
	ab 043 5 016 0		#  - a f
L  numb1
	aq NUMBER0 Xn ENDN NUMBER0
	ab 025 045 0 0		#  x .


L  board
	aq $(( alpha - 4 ))
L  shift
	aq alpha0
L  base
	aq 10
L  current
	aq decimal
L  keyc
	aq yellow
L  chars
	aq 1
L  aword
	aq EX1
L  anumber
	aq nul
L  words
	aq 1


L  nul0
	DROP
	jump l__22
L  ACCEPT

L  acceptn
	= alpha0 to shift
	address $(( alpha - 4 )) to DI
L  ACCEPT1
	= DI to board
L  l__22
	  call  KEY
	-test 4 to AL
	 when  not sign		 first
	= shift to D
	jump @ D + A *2^ 2


L  bits
	ab 28
L  l__23
	+ 0120 to A
	= 7 to CL
	jump l__24
L  PACK
	-test 020 to AL
	 when  not carry		 l__23
	= 4 to CL
	ANDtest 010 to AL
	 when  zero l__24
	1+ C
L  l__24
	= A to D
	= CL to CH
L  l__25
	-test CL to bits
	 when  not carry		 l__26
	downshift 1 to AL
	 when  carry		 FULL
	1- CL
	jump l__25
L  l__26
	upshift CL to @ SI
	- CL to bits
			return



L  LJ0
	= bits to CL
	+ 4 to CL
	upshift CL to @ SI
			return



L  LJ
	  call  LJ0
	DROP
			return



L  FULL
	  call  LJ0
	1+ words
	= 28 to bits
	- CH to bits
	= D to A
	DUP_
			return



L  X
	  call  RIGHT
	= words to A
	address @ A *2^ $(( 2 )) SI to SI

	DROP
	jump ACCEPT


L  WORD_
	  call  RIGHT
	= 1 to @ $words
	= 1 to @ $chars
	DUP_
	= 0 to @ SI
	= 28 to @ $bits
L  WORD1
	  call  LETTER
	 when  not sign		 l__27
	= shift to D
	jump @ D + A *2^ 2
L  l__27
	ANDtest AL to AL
	 when  zero WORD0
	DUP_
	  call  ECHO_
	  call  PACK
	1+ chars
L  WORD0
	DROP
	  call  KEY
	jump WORD1


L  decimal
	= 10 to @ $ base
	= numb0 to @ $shift
	= $(( numbers - 4 )) to @ $board
			return



L  hex
	= 16 to @ $base
	= numb0 to @ $shift		#  oct0
	= $(( octals - 4 )) to @ $board
			return



L  octal
	XOR $(( ( decimal - start ) ^  ( hex - start ) )) to @ $current
	  call  current

	jump NUMBER0


L  Xn
	DROP
	DROP
	jump ACCEPTn


		#  db 0 , 0 , 0 , 0
L  digit
	ab 14 10 0 0
	ab 0 0 12 0 0 0 15 0
	ab 13 0 0 11 0 0 0 0
	ab 0 1 2 3 4 5 6 7
	ab 8 9
L  sign		
	ab 0
L  MINUS
		#  mov AL , 43o		#  -
	= AL to sign		
	jump NUMBER2


L  NUMBER0
	DROP
	jump NUMBER3
L  NUMBER
	  call  current
	= 0 to sign		
	zero A
L  NUMBER3
	  call  KEY
	  call  LETTER
	 when  not sign		 l__28
	= shift to D
	jump @ D + A *2^ 2
L  l__28
	ANDtest AL to AL
	 when  zero NUMBER0
	= @ $(( digit - 4 )) A to AL
	ANDtest 037 to @ $sign		
	 when  zero l__29
	negate A
L  l__29
	= @ SI to D
	signedmultiply @ $base to D
	+ A to D
L  l__30
	= D to @ SI
L  NUMBER2
	DROP
	= numb1 to shift
	jump NUMBER3


L  ENDN
	DROP
	  call  @ $anumber
	jump ACCEPTn


L  ALPHn
	DROP
L  ALPH0
	= alpha0 to @ $shift
	address $(( alpha - 4 )) to DI
	jump l__31
L  STAR0
	= graph0 to shift
	address $(( graphics - 4 )) to DI
L  l__31
	DROP
	jump ACCEPT1


L  ALPH
	= alpha1 to shift
	address $(( alpha - 4 )) to DI
	jump l__32
L  GRAPH
	= graph1 to shift
	address $(( graphics - 4 )) to DI
L  l__32
	= DI to board
	jump WORD0


L  first
	+ $(( 4 * 4 + 4 )) to @ $shift
	  call  WORD_
	  call  @ $aword
	jump ACCEPT


L  hicon
	ab 030 031 032 033 034 035 036 037
	ab 040 041 5 023 012 020 4 016
L  eDIG1
	DUP_
L  eDIG
	push C
	= hicon @ A to AL
	  call  EMIT
	pull C
			return



L  oDIG
	uproll 4 to A
	DUP_
	AND 0x0F to A
			return



L  hdotn
	= A to D
	negate A
	address @ $(( 32 )) A *2^ 2 to C
	DROP
	uproll CL to A
	= D to C
	jump l__33
L  hdot
	= 8 to C
L  l__33
	  call  oDIG
	  call  eDIG
	next l__33
	DROP
			return



L  dot
	= 7 to C
L  l__34
	  call  oDIG
	 when  not zero at_h
	DROP
	next l__34
	1+ C
L  l__35
	  call  oDIG
L  at_h1
	  call  eDIG
	next l__35
	  call  space
	DROP
			return

L  at_h
	1+ C
	jump @h1


L  qdot
	-test 10 to base
	 when  not zero dot
L  dot10
	= A to D
	ANDtest D to D
	 when  not sign		 l__36
	negate D
	DUP_
	= 043 to A
	  call  EMIT
L  l__36
	= 8 to C
L  l__37
	= D to A
	zero D
	/ tens @ C *2^ 2
	ANDtest A to A
	 when  not zero D_1
	1- C
	 when  not sign		 l__37
	jump D_2
L  l__38
	= D to A
	zero D
	/ tens @ C *2^ 2
L  D_1
	  call  eDIG1
	1- C
	 when  not sign		 l__38
L  D_2
	= D to A
	  call  eDIG1
	  call  space		#  spcr
	DROP
			return



L  unPACK
	DUP_
	ANDtest A to A
	 when  sign		 l__39
	upshift 4 to @ SI
	uproll 4 to A
	AND 7 to A
			return

L  l__39
	upshift 1 to A
	 when  sign		 l__40
	upshift 5 to @ SI
	uproll 4 to A
	AND 7 to A
			return

L  l__40
	upshift 7 to @ SI
	uproll 6 to A
	AND 077 to A
	- 020 to AL
			return



L  qRING
	DUP_
	1+ @ SI
	-test DI insert to curs		#  from abort
	 when  not zero l__41
	= A to curs
L  l__41
	-test curs to A
	 when  zero RING
	 when  not sign		 l__42
	= DI to pcad
L  l__42
	DROP
			return



L  RING
	= DI to cad
	- $(( iw * 0x10000 )) to xy		#  bksp
	DUP_
	= 0x0e04000 to A
	  call  color
	= 060 to A
	otheroperandsize ; = $(( xy + 2 )) to CX
	otheroperandsize ; -test rm to CX
	 when  sign		 l__43
	  call  EMIT
	- $(( iw * 0x10000 )) to xy		#  bksp
			return

L  l__43
	jump EMIT


L  rW
	otheroperandsize ; = $(( xy + 2 )) to CX
	otheroperandsize ; -test lm to CX
	 when  zero l__44
	  call  cr
L  l__44
	  call  RED
	jump TYPE_


L  gW
	  call  GREEN
	jump TYPE_
L  mW
	  call  CYAN
	jump TYPE_
L  wW
	DUP_
	= yellow to A
	  call  color
	jump TYPE_


L  type0
	- $(( iw * 0x10000 )) to xy		# 	  call  bspcr
	ANDtest $(( - 020 )) to @ $(( - 4 )) DI *2^ 2
	 when  not zero type1
	1- DI
	= DI to lcad
	  call  space
	  call  qRING
	pull D		#  End of block
	DROP
	jump KEYBOARD


L  Cap
	  call  white
	DUP_
	= @ $(( - 4 )) DI *2^ 2 to A
	AND $(( - 020 )) to A
	  call  unPACK
	+ 48 to AL
	  call  EMIT
	jump type2


L  CAPS
	  call  white
	DUP_
	= @ $(( - 4 )) DI *2^ 2 to A
	AND $(( - 020 )) to A
L  l__45
	  call  unPACK
	 when  zero l__46
	+ 48 to AL
	  call  EMIT
	jump l__45


L  text
	  call  WHITE
L  TYPE_

L  type1
	DUP_
	= @ $(( - 4 )) DI *2^ 2 to A
	AND $(( - 020 )) to A
L  type2
	  call  unPACK
	 when  zero l__46
	  call  EMIT
	jump type2
L  l__46
	  call  space
	DROP
	DROP
			return



L  gsW
	= @ $(( - 4 )) DI *2^ 2 to D
	signeddownshift 5 to D
	jump gnW1


L  var
	  call  MAGENTA
	  call  TYPE_
L  gnW
	= @ DI *2^ 2 to D
	1+ DI
L  gnW1
	DUP_
	= 0x0f800 to A		#  Green
	-test dot10 to bas
	 when  zero l__47
	= 0x0c000 to A		#  dark green
	jump l__47


L  sW
	= @ $(( - 4 )) DI *2^ 2 to D
	signeddownshift 5 to D
	jump nW1


L  nW
	= @ DI *2^ 2 to D
	1+ DI
L  nW1
	DUP_
	= yellow to A
	-test dot10 to bas
	 when  zero l__47
	= 0x0c0c000 to A		#  dark yellow
L  l__47
	  call  color
	DUP_
	= D to A
	jump @ bas


L  REFRESH
	  call  SHOW
	  call  blank
	  call  text1
	DUP_		#  Counter
	= lcad to A
	= A to @ $cad		#  for curs beyond end
	zero A
	= blk to DI
	upshift $(( 10 - 2 )) to DI
	= DI to @ $pcad		#  forcurs=0 
L  ref1
	ANDtest 0x0f to @ DI *2^ 2
	 when  zero l__48
	  call  qRING
L  l__48
	= @ DI *2^ 2 to D
	1+ DI
	= dot10 to @ $bas
	ANDtest 020 to DL
	 when  zero l__49
	= dot to @ $bas
L  l__49
	AND 017 to D
	  call  display @ D *2^ 2
	jump ref1


	align 4
L  display
	aq TYPE0 wW nW rW
	aq gW gnW gsW mW
	aq sW text Cap CAPS
	aq var nul nul nul
L  tens
	aq 10 100 1000 10000 100000 1000000
	aq 10000000 100000000 1000000000
L  bas
	aq dot10
L  blk
	aq 18
L  curs
	aq 0
L  cad
	aq 0
L  pcad
	aq 0
L  lcad
	aq 0

L  trash
	aq $(( buffer * 4 ))
L  ekeys
	aq nul DEL Eout destack
	aq act1 act3 act4 shadow
	aq mcur mmcur ppcur pcur
	aq mblk actv act7 pblk
	aq nul act11 act10 act9
	aq nul nul nul nul
L  ekbd0
	aq nul nul nul nul
	ab 025 045 7 0		#  x . i
L  ekbd
	ab 017 1 015 055		#  w r g *
	ab 014 026 020 1		#  l u d r
	ab 043 011 012 053		#  - m c +
	ab 0 070 072 2		#  S C t
	ab 0 0 0 0
	ab 0 0 0 0
L  actc
	aq yellow 0 0x0ff0000 0x0c000 0 0 0x0ffff
	aq 0 0x0ffffff 0x0ffffff 0x0ffffff 0x8080ff
L  vector
	aq 0
L  action
	ab 1


L  act1
	= 1 to AL
	jump l__50
L  act3
	= 3 to AL
	jump l__50
L  act4
	= 4 to AL
	jump l__50
L  act9
	= 9 to AL
	jump l__50
L  act10
	= 10 to AL
	jump l__50
L  act11
	= 11 to AL
	jump l__50
L  act7
	= 7 to AL
L  l__50
	= AL to action
	= @ $(( actc - 4 )) A *2^ 2 to A
	= insert to @ $aword
L  actn
	= A to @ $keyc
	pull A
	DROP
	jump ACCEPT


L  actv
	= 12 to @ $action
	= 0x0ff00ff to A		#  Magenta
	= l__51 to @ $aword
	jump actn


L  l__51
	DUP_
	zero A
	1+ words
	jump insert


L  mcur
	1- curs
	 when  not sign		 l__52
L  pcur
	1+ curs
L  l__52
			return



L  mmcur
	- 8 to curs
	 when  not sign		 l__53
	= 0 to curs
L  l__53
			return

L  ppcur
	+ 8 to curs
			return



L  pblk
	+ 2 to blk
	+ 2 to @ SI
			return

L  mblk
	-test 20 to @ $blk
	 when  sign		 l__54
	- 2 to @ $blk
	- 2 to @ SI
L  l__54
			return



L  shadow
	XOR 1 to @ $blk
			return



L  E0
	DROP
	jump l__55


L  edit
	= A to @ $blk
	DROP
L  E
	DUP_

	= blk to A
	= FORMAT to @ $anumber
	= 045 to byte @ $(( alpha0 + 4 * 4 ))		#  .
	= E0 to @ $(( alpha0 + 4 ))
	  call  REFRESH
L  l__55
	= ekbd0 to @  $shift
	= $(( ekbd - 4 )) to @ $board
	= yellow to @ $keyc
L  l__56
	  call  KEY
	  call  ekeys @ A *2^ 2
	DROP
	jump l__56


L  eout
	pull A
	DROP
	DROP
	= EX1 to @ $aword
	= nul to @ $anumber
	= 0 to byte $(( alpha0 + 4 * 4 ))
	= nul0 to $(( alpha0 + 4 ))
	= yellow to @ $keyc
	jump ACCEPT


L  destack
	= trash to D
	-test $(( buffer * 4 )) to D
	 when  not zero l__57
			return

L  l__57
	- $(( 2 * 4 )) to D
	= @ D $(( + 1 * 4 )) to C
	= C to words
L  l__58
	DUP_
	= @ D to A
	- $(( 1 * 4 )) to D
	next l__58
	+ $(( 1 * 4 )) to D
	= D to @ $trash


L  insert0
	= lcad to C		#  room available?
	+ words to C
	AND $(( - 0x100 )) to C
	 when  zero insert1
	= words to C		#  no
L  l__59
	DROP
	next l__59
			return

L  insert1
	push SI
	= lcad to SI
	= SI to C
	1- SI
	= SI to DI
	+ words to DI
	upshift 2 to DI
	- cad to C
	 when  sign		 l__60
	upshift 2 to SI
	decreasing
	copies 
	increasing
L  l__60
	pull SI
	downshift 2 to DI
	1+ DI
	= DI to @ $curs		#  like abort
	= words to C
L  l__61
	1- DI
	= A to @ DI *2^ 2
	DROP		#  requires cld
	next l__61
			return



L  insert
	  call  insert0
	= action to CL
	jump ACCEPT


L  FORMAT
	ANDtest 012 to @ $action		#  ignore 3 and 9
	 when  zero l__62
	DROP
			return

L  l__62
	= A to D
	AND 0x0FC000000 to D
	 when  zero l__63
	-test 0x0FC000000 to D
	 when  not zero FORMAT2
L  l__63
	upshift 5 to A
	-test 4 to @ $action
	 when  zero l__64
L  l__64
	-test 10 to @ $base
	 when  zero l__65
L  l__65
	= 1 to @ $words
	jump insert


L  FORMAT2
	DUP_
	= 1 to A		#  5
	-test 4 to @ $action
	 when  zero l__66
	= 3 to AL		#  2
L  l__66
	-test 10 to @ $base
	 when  zero l__67
L  l__67
	swap @ SI to A
	= 2 to @ $words
	jump insert


L  DEL
	  call  enstack
	= pcad to DI
	= lcad to C
	- DI to C
	upshift 2 to DI
	push SI
	= cad to SI
	upshift 2 to SI
	copies pull SI
	jump mcur


L  enstack
	DUP_
	= cad to A
	- pcad to A
	 when  zero ens
	= A to C
	swap D to A
	push SI
	= cad to SI
	address @ SI *2^ $(( 2 - 4 )) to SI
	= trash to DI
L  l__68
	decreasing
	ab 0xad		#  ### lodsd
	increasing
	ab 0xab		#  ### stosd
	next l__68

	swap D to A
	ab 0xab		#  ### stosd
	= DI to @ $trash
	pull SI
L  ens
	DROP
			return



L  pad
	pull D
	= D to @ $vector
	+ $(( 28 * 5 )) to D
	= D to @ $board
	- $(( 4 * 4 )) to D
	= D to @ $shift
L  l__69
	  call  KEY
	= vector to D
	+ A to D
	address @ 5 A *2^ 2  D to D
	+ @  -4  D to D
	DROP
	  call  D
	jump l__69


H=$(((0x1200-  1 ) * 4))
	aq 0
	end start

