		#  UNMASM
		#  / Ha3sm / reference / Forthy / colorForth
		#  GEN.ASM
		#  Sat Aug 23 11:18:43 2003

		#  Generic graphics


	align 4
L  frame
	aq $(( 0x2000000 - hp * vp * 2 ))		#  32 M
L  displ
	aq 0x0f0000000		#  fujitsu
L  fore
	aq 0x0f7de
L  xc
	aq 0
L  yc
	aq 0


L  rgb
	ror 8 to A
	downshift 2 to AX
	ror 6 to A
	downshift 3 to AL
	uproll $(( 6 + 5 )) to A
	AND 0x0f7de to A
			return



L  white
	DUP_
	= 0x0ffffff to A
L  color
	  call  rgb
	= A to fore
	DROP
			return



L  north
	= 0x0cf8 to D
	send A to DX
	+ 4 to D
	recieve DX to A
			return



L  dev
	= 0x80001008 start at device 2 to A		#  Find display
	= $(( 31 - 1 )) bus 1 dev 0 to C		#  end with AGP: 10008
L  l__1
	DUP_
	  call  north
	AND 0x0ff000000 to A
	-test 0x3000000 to A
	DROP
	 when  zero l__2
	+ 0x800 to A
	next l__1
L  l__2
			return



L  ati0
	  call  dev
	OR 2 to @ A $(( - 4 ))		#  Enable memory
	+ $(( 0x24 - 8 )) to AL		#  look for prefetch
	= 5 to CL
L  l__3
	DUP_
	  call  north
	 when  zero l__4
	DROP
	- 4 to A
	next l__3
	DUP_
	  call  north
	AND 0x0fffffff0 to A

L  l__4
	= A to displ
	DROP
			return



L  fifof
	DROP
L  graphic
			return



L  switch

		#  DUP_
	push SI
	= frame to SI
	push DI
	= displ to DI		#  0f2000000h eMonster Nvidia
		#  xor EAX , EAX
	= $(( hp * vp / 2 )) to C
		#  @@: lodsd
		#  add EAX , @ EDI
		#  rcr EAX , 1
		#  and EAX , 0f7def7deh
	ab 0xab		#  ### FILL ONE CELL?# next @b
	copies pull DI
	pull SI
		#  DROP
	jump PAUSE


L  clip
	= xy to DI
	= DI to C
	ANDtest CX to CX
	 when  not sign		 l__5
	zero C
L  l__5
	AND 0x0ffff to C
	= C to yc
	signedmultiply $(( hp * 2 )) to C
		#  << ECX , 10 + 1
	signeddownshift 16 to DI
	 when  not sign		 l__6
	zero DI
L  l__6
	= DI to xc
	address @ DI *2^ $(( 1 )) C to DI
	+ frame to DI
			return



L  bit16
	lodsw
	swap AH to AL

	= 16 to C
L  b16
	upshift 1 to AX
	 when  not carry		 l__7
	= DX to @ DI
L  l__7
	+ 2 to DI
	next b16
			return



L  bit32
	lodsw
	swap AH to AL
	= 16 to C
L  b32
	upshift 1 to A
	 when  not carry		 l__8
	= DX to @ DI
	= DX to @ DI $(( + 2 ))
	= DX to @ DI $(( + hp * 2 ))
	= DX to @ DI $(( + hp * 2 + 2 ))
L  l__8
	+ 4 to DI
	next b32
			return



L  emit
	  call  qcr
	push SI
	push DI
	push D
	signedmultiply $(( 16 * 24 / 8 )) to A
	address icons @ A to SI
	  call  clip
	= fore to D
	= 24 to C
L  l__9
	push C
	  call  bit16
	+ $(( ( hp - 16 ) * 2 )) to DI
	pull C
	next l__9
	pull D
	pull DI
	pull SI
L  BL_
	DROP
L  SPACE
	+ $(( iw * 0x10000 )) to xy
			return



L  emit2
	push SI
	push DI
	push D
	signedmultiply $(( 16 * 24 / 8 )) to A
	address icons @ A to SI
	  call  clip
	= fore to D
	= 24 to C
L  l__10
	push C
	  call  bit32
	+ $(( ( 2 * hp - 16 * 2 ) * 2 )) to DI
	pull C
	next l__10
	pull D
	pull DI
	pull SI
	+ $(( iw * 0x10000 * 2 )) to xy
	DROP
			return



L  text1
	  call  WHITE
	= 3 to lm
	= $(( hc * iw )) to rm
	jump TOP


L  line
	  call  clip
	= @ SI to C
	upshift 1 to C
	- C to DI
	= A to C
	= fore to A

	otheroperandsize $(( ; fill 1+ xy ))
	DROP
	DROP
			return



L  box
	  call  clip
	-test $(( vp + 1 )) to A
	 when  sign		 l__11
	= vp to A
L  l__11
	= A to C
	- yc to C
	jng no
	-test $(( hp + 1 )) to @ SI
	 when  sign		 l__12
	= hp to @ SI
L  l__12
	= xc to A
	- A to @ SI
	jng no
	= hp to D
	- @ SI to D
	upshift 1 to D
	= fore to A
L  l__13
	push C
	= @ SI to C
	otheroperandsize D to $(( ; fill )) DI
	pull C
	next l__13
L  no
	DROP
	DROP
			return


